#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "vigenere.h"

int main(int argc,char *argv[])
{
  if (argc == 1)
  {
    std::cerr << "Appel invalide : " << argv[0] << " fichier\n";
    return 1;
  }

  try
  {
    std::string ifname(argv[1]);

    std::ifstream ifs(ifname.c_str());
    if ( !ifs )
    {
      std::cerr << "Erreur d'ouverture de " << ifname << std:: endl;
      return 1;
    }

    std::ostringstream ofname;
    ofname << ifname << ".vig";

    std::ofstream ofs(ofname.str().c_str());
    if ( !ofs )
    {
      std::cerr << "Erreur d'ouverture de " << ofname << std:: endl;
      return 1;
    }

    std::cout << "Entrez la cle : ";
    std::string key;
    std::cin >> key;
    if ( key.empty() )
    {
      std::cerr << "Cl vide\n";
      return 1;
    }

    vigenere codeur(key);

    std::string line;
    while ( getline(ifs,line) )
      ofs << codeur.crypt(line) << std::endl;

  }
  catch ( std::exception &err )
  {
    std::cerr << "Erreur : " << err.what() << std::endl;
    return 1;
  }
  
  return 0;
}
