#ifndef VIGENERE_H_INCLUDED
#define VIGENERE_H_INCLUDED

#include <string>
#include <vector>

class vigenere
{
  public:
    explicit vigenere(const std::string &key) :
      key_(code(transform(key)))
    { }
    std::string crypt(const std::string &message) const;
    std::string decrypt(const std::string &message) const;
  private:
    static std::string transform(const std::string &st);
    static std::vector<unsigned short> code(const std::string &st);
    static std::string decode(const std::vector<unsigned short> &mess);
    std::vector<unsigned short> extend_key(unsigned int n) const;
    std::vector<unsigned short> key_;
};

#endif
