#include <iostream>
#include <string>

#include "vigenere.h"

using std::string;
using std::cout;
using std::cerr;
using std::endl;

int main()
{
  string msg("Les feuilles mortes se ramassent a la pelle,");
  string expects("AVWAILBACINQFKIVWNIITBRWNIEMPCEKICET");
  string key("PREVERT");

  vigenere codeur(key);

  cout << "Testing vigenere";
  string result=codeur.crypt(msg); 
  if ( result != expects ) 
  {
    cerr << "Le test n'a pas russi : \n"
     << result << "!=" << expects << endl; 
    cout << "!";
  }
  else
    cout << ".";
  
  string msg_res=codeur.decrypt(result);
  expects="LESFEUILLESMORTESSERAMASSENTALAPELLE";

  if ( msg_res != expects )
  {
    cerr << "Le test n'a pas russi : \n"
     << msg_res << "!=" << expects << endl; 
    cout << "!";
  }
  else
    cout << ".";

  msg="AXYZWK";
  vigenere codeur1("THEKEY");
  result=codeur1.decrypt(codeur1.crypt(msg));

  if (result != msg)
  {
    cerr << "Le test n'a pas russi : \n"
     << result << "!=" << msg << endl; 
    cout << "!";
  }
  else
    cout << ".";

  cout << "END\n";

  return 0;
}
